<?php
/////////////////////////////////////////////////////////////////////////////////////////
// Voip Call/Bill Calculator by S. Young-Smith (syoungsmith a/t gmail d/t com) 2010.10.12
//
//  Uses "fincheck.php" (named here "voip.php") by Simon G <junk a/t simong d/t net> and Enzo Michelangeli
//		callcalc.php - processing of call data retrieved via voip.php using supplied config.ini data
//		index.php - example of how to display all calls and charges as set through config.ini
//		front.php - some front end configuration which is stored in config.ini
//		writeini.php - to save the configuration data in php ini format
//		login.php - redirect to front.php after login
//		logout.php - destroy login session
//		
//      PASSWORD = "longcalls" probably you should change this! See line 6 in login.php
//
//		Place all files in same directory and bring up the configuration page by going to
//			login.php - password is "longcalls".
//		Bring up index.php to see an example of usage
//
// Restricted to the Creative Commons License because the script also makes use of
//    tableextr.php class by Jack Sleight - if anyone can find a good unrestricted table
//    extractor class please let me know - thankyou - Otherwise until then my understanding
//		is that commecial use is not allowed.
// 
// 	A list of current BASE URL's  (list correct 2010.10.11)
//		https://www.12voip.com/myaccount
//		https://www.actionvoip.com/myaccount
//		https://www.budgetsip.com/myaccount
//		https://www.calleasy.com/myaccount
//		https://www.cheapvoip.com/myaccount
//		https://www.dialnow.com/myaccount
//		https://www.freecall.com/myaccount
//		https://www.internetcalls.com/myaccount
//		https://www.intervoip.com/myaccount
//		https://www.jumblo.com/myaccount
//		https://www.justvoip.com/myaccount
//		https://www.lowratevoip.com/myaccount
//		https://www.netappel.fr/myaccount
//		https://www.nonoh.net/myaccount
//		https://www.poivy.com/myaccount
//		https://www.powervoip.com/myaccount
//		https://www.rynga.com/myaccount
//		https://www.sipdiscount.com/myaccount
//		https://www.smartvoip.com/myaccount
//		https://www.smsdiscount.com/myaccount
//		https://www.smslisto.com/myaccount
//		https://www.sparvoip.de/myaccount
//		https://www.voipbuster.com/myaccount
//		https://www.voipbusterpro.com/myaccount
//		https://www.voipcheap.co.uk/myaccount
//		https://www.voipcheap.com/myaccount
//		https://www.voipdiscount.com/myaccount
//		https://www.voipgain.com/myaccount
//		https://www.voipraider.com/myaccount
//		https://www.voipstunt.com/myaccount
//		https://www.voipwise.com/myaccount
//		https://www.voipzoom.com/myaccount
//		https://www.webcalldirect.com/myaccount
//	Enjoy!
//
/////////////////////////////////////////////////////////////////////////////////////////


include("tablextr.php");
include("voip.php");
$config = parse_ini_file("config.ini", "true");  //read in all the configuration data
$startdate = $config[billdetails][startdate];
$starttime = $config[billdetails][starttime];
$enddate = $config[billdetails][enddate];
$endtime = $config[billdetails][endtime];
$BASEURL = $config[account][BASEURL];     //voip.php needs this set

//calculate unix start time for bill from $startdate and $starttime
list($startyear, $startmonth, $startday) = explode('-', $startdate);
list($starthour, $startminute, $startsecond) = explode(':', $starttime);
$config[billstarttime] = mktime($starthour, $startminute, $startsecond, $startmonth, $startday, $startyear);
list($endyear, $endmonth, $endday) = explode('-', $enddate);
list($endhour, $endminute, $endsecond) = explode(':', $endtime);
$config[billendtime] = mktime($endhour, $endminute, $endsecond, $endmonth, $endday, $endyear);

//perform initial login
login($config[account][voipusername], $config[account][voippassword]);

//print_r(gomainpage());

//Create an array with months and years between start and end dates for collecting the relevant pages from your voip provider.
//list($startyear, $startmonth, $startday) = explode('-', $config[billdetails][startdate]);
//list($endyear, $endmonth, $endday) = explode('-', $config[billdetails][enddate]);
$date_array = array();
$dt_row = 0;
$date_array[$dt_row]['month'] = $startmonth;
$date_array[$dt_row]['year'] = $startyear;
$cmonth = $startmonth;
$cyear = $startyear;
while(!($cmonth == $endmonth && $cyear == $endyear)){
	$dt_row++;
	if($cmonth == 12){ $cyear = $cyear+1; $cmonth = 1;}
	$cmonth = $cmonth+1;
	$date_array[$dt_row]['month'] = $cmonth;
	$date_array[$dt_row]['year'] = $cyear;
}

//create array to hold all calls and initialise $row_no
$allcalls = array();
$row_no = 0;

//Populate the $allcalls array by calling 'callcalc' function passing it most recent month
While($dt_row != -1){
	callcalc($allcalls, $row_no, $config, $date_array[$dt_row]['month'], $date_array[$dt_row]['year']);
	$dt_row--;
}

function callcalc(&$allcalls, &$row_no, $config, $fnmonth, $fnyear){
	//Calls for the month which has been passed to this function
	list($sContent, $iThisResult, $sThisDebug) = doRequest($config['account']['BASEURL']."/calls.php?month=".$fnmonth."&year=".$fnyear);
	//echo $sThisDebug;
	//echo $iThisResult;
	//echo $sContent;
	
	//check that the returned page '$sContent' has the 'callstable' string in it, otherwise it is empty
	if(stripos($sContent, 'callstable') === FALSE) return;
	
	$tbl = new tableExtractor;
	$tbl->source = $sContent; // Set the HTML Document
	$tbl->anchor = 'callstable'; // Set an anchor that is unique and occurs before the Table
	$tbl->anchorWithin = true; // To use a unique anchor within the table to be retrieved
	$call_list = $tbl->extractTable(); // The returned array

	//print_r($call_list);
	
	foreach($call_list as $call)
	{
		//Make Unix time stamp from voip call date time so as call time can be adjusted to local time
		list($year, $month, $day) = explode('-', $call[Date]);
		$year = preg_replace("/[^0-9\.]/", '', $year);  //remove tags before year
		list($hour, $minute, $second) = explode(':', $call[Time]);
		$UnixCallTime = mktime($hour, $minute, $second, $month, $day, $year) + ($config[general][timeshift]*60*60);
		
		//Get number called
		$numbercalled = $call['Number called'];

		//Check that the call time is between the start and end dates and times
		if($UnixCallTime < $config[billstarttime] || $UnixCallTime > $config[billendtime]) continue;
		
		//Check details from the number field to see if the line item should be listed
		foreach($config[donotlist] as $text){
			if(stripos($numbercalled,$text) !== false) continue 2;
		}
	
		$allcalls[$row_no][Date] = trim($call[Date]);
		$allcalls[$row_no][Time] = trim($call[Time]);
		$allcalls[$row_no][UnixCallTime] = $UnixCallTime;
		
		//Now remove any text characters remaining in the number field to get rid of comments such as '(Free Days Expired)' etc
		$numbercalled = ereg_replace("[^0-9+]", "",  $numbercalled);
		$allcalls[$row_no]['Number called'] = $numbercalled;
		
		//Get call duration
		$allcalls[$row_no][Duration] = $call[Duration];
		
		//Calculate call duration in whole minutes
		list($Dhour, $Dminute, $Dsecond) = explode(':', $call[Duration]);
		$CallMinutes = ($Dhour*60) + $Dminute;
		$Dsecond > 0 ? $CallMinutes = $CallMinutes + 1 : $CallMinutes = $CallMinutes ;
		$allcalls[$row_no][Minutes] = $CallMinutes;
		
		//Extract decimal cost of call
		$amount = $call[Amount];
		$amount = preg_replace("/[^0-9\.]/", '', $amount);
		$amount = $amount+0;
		$allcalls[$row_no][Amount] = $amount;
		
		//calculate minimum call cost, regular call cost and choose the higher of the two
		$mincallcost = $config[general][mincallcostpm] * $CallMinutes;
		$regcallcost = $amount * $config[general][costmultiplier];
		$mincallcost > $regcallcost ? $callcost = $mincallcost : $callcost = $regcallcost;
		
		//Now check for specific multipliers
		$specificmultiplierskeys = array_keys($config[specificmultipliers]);
		foreach($specificmultiplierskeys as $specificmultiplierkey){
			list($multiplier, $minpm) = explode(":", $config[specificmultipliers][$specificmultiplierkey]);
			if(strpos(numbertidy($numbercalled),numbertidy($specificmultiplierkey)) === 0){
				$callcost = $multiplier * $amount;
				if($callcost < ($minpm * $CallMinutes)) $callcost = $minpm * $CallMinutes; 
				continue;
			}
		}
		
		//now check for numbers free to call
		//print_r($fnfreenumbers);
		foreach($config[freenumbers] as $freenumber){
			if(strpos(numbertidy($numbercalled),numbertidy($freenumber)) === 0){$callcost = 0; continue;}
		}
		$allcalls[$row_no][CallCost] = number_format($callcost, 2, '.', '');
		$allcalls[$row_no][MinCost] = $mincallcost; 
		
		//increment row number
		$row_no++;
	}
}

//below is function to remove '+' or '00' from begining of numbers and any white space or non-breaking spaces i.e. &nbsp
//this way we know that we will only be comparing numbers in the same international format!
function numbertidy($telnumber){
	$telnumber = trim($telnumber);
	$telnumber = trim($telnumber, chr(0xA0));
	$telnumber = trim($telnumber, chr(0xC2).chr(0xA0));
	$telnumber = trim($telnumber);
	$telnumber = trim($telnumber, '+');
	$telnumber = ltrim($telnumber, '0');
	return $telnumber;
}
?>