<?php
/////////////////////////////////////////////////////////////////////////////////////////
// Voip Call/Bill Calculator by S. Young-Smith (syoungsmith@gmail.com)
//
// For use with "fincheck.php" (named here "voip.php") by Simon G <junk@simong.net>
//		callcalc.php - processing of call data retrieved via voip.php using supplied config.ini data
//		index.php - example of how to display all calls and charges as set through config.ini
//		front.php - some front end configuration which is stored in config.ini
//		writeini.php - to save the configuration data in php ini format
//		login.php - redirect to front.php after login
//		logout.php - destroy login session
//
//      PASSWORD = "longcalls" probably you should change this! See line 6 in login.php
//
//		Place all files in same directory and bring up the configuration page by going to
//			login.php - password is "longcalls".
//		Bring up index.php to see an example of usage
//
// Restricted to the Creative Commons License because the script also makes use of
//    tableextr.php class by Jack Sleight - if anyone can find a good unrestricted table
//    extractor class please let me know - thankyou - Otherwise until then my understanding
//		is that commecial use is not allowed.
// 
// 	A list of current BASE URL's  (list correct 2010.10.11)
//		https://www.12voip.com/myaccount
//		https://www.actionvoip.com/myaccount
//		https://www.budgetsip.com/myaccount
//		https://www.calleasy.com/myaccount
//		https://www.cheapvoip.com/myaccount
//		https://www.dialnow.com/myaccount
//		https://www.freecall.com/myaccount
//		https://www.internetcalls.com/myaccount
//		https://www.intervoip.com/myaccount
//		https://www.jumblo.com/myaccount
//		https://www.justvoip.com/myaccount
//		https://www.lowratevoip.com/myaccount
//		https://www.netappel.fr/myaccount
//		https://www.nonoh.net/myaccount
//		https://www.poivy.com/myaccount
//		https://www.powervoip.com/myaccount
//		https://www.rynga.com/myaccount
//		https://www.sipdiscount.com/myaccount
//		https://www.smartvoip.com/myaccount
//		https://www.smsdiscount.com/myaccount
//		https://www.smslisto.com/myaccount
//		https://www.sparvoip.de/myaccount
//		https://www.voipbuster.com/myaccount
//		https://www.voipbusterpro.com/myaccount
//		https://www.voipcheap.co.uk/myaccount
//		https://www.voipcheap.com/myaccount
//		https://www.voipdiscount.com/myaccount
//		https://www.voipgain.com/myaccount
//		https://www.voipraider.com/myaccount
//		https://www.voipstunt.com/myaccount
//		https://www.voipwise.com/myaccount
//		https://www.voipzoom.com/myaccount
//		https://www.webcalldirect.com/myaccount
//	Enjoy!
//
/////////////////////////////////////////////////////////////////////////////////////////
session_start();
if ($_SESSION['loggedin'] !== true) {
    header('Location: login.php');
    exit;
}


include('writeini.php');

if(isset($_POST['save'])){
	$fns = array();
	while (list($key, $val) = each($_POST['freenumber'])) {
		if(trim($val) != "") $fns[] = $val;
	}
	$dnl = array();
	while (list($key, $val) = each($_POST['donotlist'])) {
		if(trim($val) != "") $dnl[] = $val;
	}
	$sm = array();
	while (list($key, $val) = each($_POST['sm_key'])) {
		if( !(trim($val) == "" || trim($_POST['sm_value'][$key])=="")){
			trim($_POST['sm_min'][$key]) == "" ? $sm_min = $_POST['mincallcostpm'] : $sm_min = $_POST['sm_min'][$key];
			$sm[$val] = trim($_POST['sm_value'][$key]).":".trim($sm_min);
		}
	}
	$Data = array(
					'account' => array(
						'voipusername' => $_POST['voipusername'],
						'voippassword' => $_POST['voippassword'],
						'BASEURL' => $_POST['BASEURL'],
					),
					'general' => array(
						'timeshift' => $_POST['timeshift'],
						'costmultiplier' => $_POST['costmultiplier'],
						'mincallcostpm' => $_POST['mincallcostpm'],
						'title' => $_POST['title'],
					),
					'billdetails' => array(
						'startdate' => $_POST['startdate'],
						'enddate' => $_POST['enddate'],
						'starttime' => $_POST['starttime'],
						'endtime' => $_POST['endtime'],
					),
					'freenumbers' => $fns,
					'donotlist' => $dnl,
					'specificmultipliers' => $sm
					);
	 write_ini_file($Data, 'config.ini', true);
	$saved = true;
}
$config = parse_ini_file("config.ini", "true");  //read in all the configuration data
$voipusername = $config[account][voipusername];
$voippassword = $config[account][voippassword];
$BASEURL = $config[account][BASEURL];
$timeshift = $config[general][timeshift];
$costmultiplier = $config[general][costmultiplier];
$mincallcostpm = $config[general][mincallcostpm];
$title = $config[general][title];
$startdate = $config[billdetails][startdate];
$enddate = $config[billdetails][enddate];
$starttime = $config[billdetails][starttime];
$endtime = $config[billdetails][endtime];
//print_r($_POST['donotlist']);
?>
<html>
<head>
<title>Front End Configuration</title>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/> 
<style type="text/css">  
th{  
	border-bottom:2px solid #005000;  
}  
</style>  
</head>
<body>
<a href="logout.php">LOGOUT</a>
<?php if($saved===true) echo "Configuration Saved as Listed Below:";?>
	<form method="post">
	<table>
	<tr><th colspan=2>Bill Details</td></tr>
	<tr><td>Start Date(yyyy-mm-dd): </td><td><input name='startdate' type='text' value='<?php echo $startdate ?>'/><td/></tr>
	<tr><td>End Date  (yyyy-mm-dd): </td><td><input name='enddate' type='text' value='<?php echo $enddate ?>'/><td/></tr>
	<tr><td>Start Time(hh-mm-ss): </td><td><input name='starttime' type='text' value='<?php echo $starttime ?>'/><td/></tr>
	<tr><td>End Time  (hh-mm-ss): </td><td><input name='endtime' type='text' value='<?php echo $endtime ?>'/><td/></tr>
	<tr><td colspan=2>&nbsp;</td></tr>
	<tr><th colspan=2>Account Details</td></tr>
	<tr><td>VOIP Username: </td><td><input name='voipusername' type='text' value='<?php echo $voipusername ?>'/><td/></tr>
	<tr><td>VOIP Password: </td><td><input name='voippassword' type='password' value='<?php echo $voippassword ?>'/><td/></tr>
	<tr><td>BASE URL: </td><td><input name='BASEURL' type='text' value='<?php echo $BASEURL ?>' size='50'/><td/></tr>
	<tr><td colspan=2>&nbsp;</td></tr>
	<tr><th colspan=2>General</td></tr>
	<tr><td>Time Differnce (Hrs)</td><td><input name='timeshift' type='text' value='<?php echo $timeshift ?>'/><td/></tr>
	<tr><td>Cost Multiplier</td><td><input name='costmultiplier' type='text' value='<?php echo $costmultiplier ?>'/><td/></tr>
	<tr><td>Minimum Call Cost pm</td><td><input name='mincallcostpm' type='text' value='<?php echo $mincallcostpm ?>'/><td/></tr>
	<tr><td>Bill Title</td><td><input name='title' type='text' value='<?php echo $title ?>' size='65'/><td/></tr>
	<tr><td colspan=2>&nbsp;</td></tr>
	<tr><th colspan=2>Free Numbers</td></tr>
	<?php foreach($config[freenumbers] as $freenumber){
	$fr_row++; ?>
	<tr><td>Free Number <?php echo $fr_row ?>:</td><td><input name='freenumber[]' type='text' value='<?php echo $freenumber ?>'/><td/></tr>
	<?php
	}
	?>
	<tr><td>Free Number <?php echo $fr_row+1 ?>:</td><td><input name='freenumber[]' type='text'/><td/></tr>
	<tr><td>Free Number <?php echo $fr_row+2 ?>:</td><td><input name='freenumber[]' type='text'/><td/></tr>
	<tr><td colspan=2>&nbsp;</td></tr>
	<tr><th colspan=2>Numbers or items not to show on bill</td></tr>
	<?php foreach($config[donotlist] as $donotlist){
	$dnl_row++; ?>
	<tr><td>Item <?php echo $dnl_row ?>:</td><td><input name='donotlist[]' type='text' value='<?php echo $donotlist ?>'/><td/></tr>
	<?php
	}
	?>
	<tr><td>Item <?php echo $dnl_row+1 ?>:</td><td><input name='donotlist[]' type='text'/><td/></tr>
	<tr><td>Item <?php echo $dnl_row+2 ?>:</td><td><input name='donotlist[]' type='text'/></td></tr>
	
	<tr><td colspan=2>&nbsp;</td></tr>
	</table>
	<table>
	<tr><th colspan=6>Specific Charge Multipliers</th></tr>
	<?php while (list($key, $val) = each($config['specificmultipliers'])){
		list($value, $min) = (explode(":",$val));
		$dnl_row++;
	?>
	<tr><td>Prefix or full number</td><td><input name='sm_key[]' type='text' value='<?php echo $key?>' /></td>
		<td>Multiplier</td><td><input name='sm_value[]' type='text' value='<?php echo $value ?>' size='4'/></td>
		<td>Min Cost</td><td><input name='sm_min[]' type='text' value='<?php echo $min ?>' size='4'/></td></tr>
	<?php
	}
	?>
	<tr><td>Prefix or full number</td><td><input name='sm_key[]' type='text' /></td>
		<td>Multiplier</td><td><input name='sm_value[]' type='text' size='4'/></td>
		<td>Min Cost</td><td><input name='sm_min[]' type='text' size='4'/></td></tr>
	<tr><td>Prefix or full number</td><td><input name='sm_key[]' type='text' /></td>
		<td>Multiplier</td><td><input name='sm_value[]' type='text' size='4'/></td>
		<td>Min Cost</td><td><input name='sm_min[]' type='text' size='4'/></td></tr>
	<tr><td colspan=6>&nbsp;</td></tr>
	<tr><td colspan=6><input type='submit' name='save' value='save'/></td></tr>
	</table>
	</form>
</body>
</html>